// demonstrates difference between class and instance variables

public class StaticExample {
	// static variable
   private static int noObjects = 0;
   private int id;
   
   // constructor
   public StaticExample(int k) { 
   		id=k; 
   		noObjects++; 
   }
   
   // static method, try making it non static and see the differences....
   public static int getNoObjects() {
      return noObjects;
   }
   
   public static void main(String[] args) {
		StaticExample n0 = new StaticExample(15); 
		System.out.println(n0.getNoObjects()); // should print 1, have to do this if non-static to invoke it....
		System.out.println(StaticExample.getNoObjects()); // 1 
		StaticExample n1 = new StaticExample(17);
    	System.out.println(StaticExample.getNoObjects()); // 2
		StaticExample n2 = new StaticExample(22);
		System.out.println(StaticExample.getNoObjects()); // 3	
	}
	
}
