// demonstrates usage modifiers for variables and methods

public class UsageModifiers {

	// class variable
	private static int i = 0;  // show what happens if we remove the static modifier!					   
	// EXERCISE: add code to show how to count the number of objects created!
	
	// instance variable
	private int s = 0;  // there is one of these for every object created.... 					 
	
	// class method
	public static int numOfObjects () {
		// System.out.println("can I access s = " + s); // can't do this because s is not static... 
		System.out.println("can I access i = " + i);
		return i;
	}
	
	// instance method
	public int state  () {
		System.out.println("can I access i = " + i);
		System.out.println("can I access s = " + s);
		i++; 
		return s;
	}
	
	public UsageModifiers () {
		i++;
		s++;
	}
	
	public static void main (String args[]) {

		UsageModifiers u1 = new UsageModifiers();
		System.out.println("i in u1 = " + u1.i); // why the warnings?
		
		UsageModifiers u2 = new UsageModifiers();
		System.out.println("i in u2 = " + u2.i);
		System.out.println("i in u1 = " + u1.i);
		
		System.out.println("i is: " + UsageModifiers.i);						
	}
}