package shapes;

public class Shape {
	// fields which will be inherited 
	// but if you say private, they won't be
	// EXERCISE:  check what happens if you make one private
	// public int numOfSides; // does this belong here do you think?
	public String colour;
	public int numOfSides = 1;  // by default only one side...
	
	// note:  constructors arent inherited, check!
	public Shape ( ) {
		colour = "red"; // default colour
		System.out.println("Shape constructor called");
	}

	// methods which will be inherited (or overridden)
	// if they are private will be inherited?
	public String getColour ( ) {
		return colour;
	}
	public int getNumOfSides ( ) {
		return numOfSides;
	}
	public void setColour(String c) {
		colour = c;
	}
	public void setNumOfSides (int n ) {
		numOfSides = n;
	}
	public String toString () {
		return "This is a " + colour + " " + numOfSides + " sided figure";
	}
}

