// Tester for AlarmClock

package clock;

public class Tester {

	public static void main(String[] args) {

// Step1:  first make sure you understand these few lines!
		Clock myClock = new Clock();
		myClock.setTime(10,24);
		myClock.displayTime();
		// so far so good, right!

/* Step2:  Now add in this next section
		AlarmClock myAlarm = new AlarmClock();
		myAlarm.setTime(11, 30);
		myAlarm.setAlarm(12, 20);
		myAlarm.displayTime();
		myAlarm.displayAlarm();
*/
	
/* Step 3:  add in next few lines
		// what is myalarm?
		if (myAlarm instanceof AlarmClock)
			System.out.println("myAlarm is an alarm"); // makes sense...
		if (myAlarm instanceof Clock)
			System.out.println("myAlarm is a clock");   // ah it is also a clock because an alarmclock is a clock!
*/

/* Step 4:  now these....			
		// what is myclock?
		if (myClock instanceof Clock)
			System.out.println("myClock is a clock");   // makes sense
		if (!(myClock instanceof AlarmClock))
		System.out.println("but myClock is NOT an alarmclock"); 
		// draw the inheritance hierarchy to be sure you understand what is going on here!
*/

/* Step 5:  ok, let's dig a bit more... so what can we really do here!
		Clock c = myAlarm;  // make a clock object refer to an alarmclock object 
		if (c instanceof AlarmClock)
				System.out.println("c is an alarm"); // yes it is referring to an alarmclock
		if (c instanceof Clock)
					System.out.println("c is a clock");    // and an alarmclock is a clock.... so yes it is a clock
		((AlarmClock) c).displayAlarm();   // NOTE: must cast!  what happens if you don't?
		// Tip: we have to do this because c is of type Clock and Clock doesn't have this method....
		// but we know it is really referring to an alarmclock so we can cast and call this method
		// The way to be sure of that is to check if it is referring to an instance of alarmclock before doing the cast
*/

// Step 6:  try uncommenting this next line here....
     // AlarmClock a = myClock;  
		// We can't do this because the Clock objects do not have all the methods required by an alarmclock object... 
		// for example, we couldn't make a call to displayAlarm() if such a thing were allowed.... 
	}

}
