public class Find {

	// this one will cause a runtime exception, why?
	static boolean find1(int[] a, int b) {
		System.out.println("Entering find1 method");
		int i=0; 
		while(true) if (a[i++] == b)
			return true;
	}

	// this one also causes an exception but it is caught
	static boolean find2(int[] a, int b) {
	   System.out.println("Entering find2 method");
	   try {
		  int i=0;
		  while(true) if (a[i++] == b) return true;
	   } catch (ArrayIndexOutOfBoundsException e) {
		  return false;
	   } finally {
		  System.out.println("Exiting find method");
	   }
	}

	public static void main ( String[] args) {
		int [] a = {1,2,3};
		System.out.println("found it or not = " + Find.find2(a,4));
		// EXERCISE: Try uncommenting the next line -- explore the
		// difference between the two find methods... 
		System.out.println("found it or not = " + Find.find1(a,4));

	}

}
