// Goals of this code is to show how to do debugging
// of logic errors
// Notes:  notice use of debug routine, use of white space in output
// the ability to turn debugging on/off 

public class LogicalErrors {
	private static final boolean DEBUG = false;  // set it to true and see what happens
	
	public static void debug(String s) {
			if ( DEBUG == true ) {
				System.out.println("   debug: " + s);
			}
		}

	public static int calculate_factorial(int n) {
		int result = 1;
		for (int i =n; i>=0; i--) {
			 result = i*result;
			 debug("i = " + i + "; result = " + result + "; n = " + n);
		}
		return result;
	}
		
	public static void main ( String[] args ) {
		int n = 5;	// answer should be 120
		System.out.println(n + "! is " + LogicalErrors.calculate_factorial(n));
		// note because I made the above method static I don't have to
		// create an object to call that method
	}
}
	
