// Demonstrates how "friendly" classes work

import shapes.Shape;

public class FriendlyClasses {  
	// to demonstrate the purpose of "friendly" 
	// remove public from Shape in Shape.java, and 
	// show that importing it will not make 
	// it accessible (friendly by default)
	// See what the difference is when you copy 
	// Shape to the same package... 
	
	public static void main (String args[]) {
	 	Shape s = new Shape();   
	    System.out.println("shape's colour is = " 
			+ s.getColour());
	}
}