package pirates; 

// What does it mean to declare a class as abstract?
abstract public class Pirate{

 // This variable will be inherited by all children of the Pirate class.
 // Run the code.  How many swords are handed out in total?  Can you change
 // this line to report the proper number in total?  (Hint: one keyword is missing!).
 protected int sword = 0;

 // constructor
 public Pirate(){
  handOutSword(); 
  System.out.println("Swords handed out: " + sword);
 } 
 
 private void handOutSword () {
  sword++;
 }
 
 void speak(){
  System.out.println("Yar!"); 
 }
 
 public void sleep(){
  System.out.println("zzz...zzz");
 }
 
 // What is required of the subclasses of Pirate when the superclass (this one)
 // has a method declared as abstract?
 abstract void fight();
 


}