interface Fighter {	
  void fight();
}

interface Swimmer {
  void swim();
}

interface Flyer {
  void fly();
}

class ActionCharacter {
  // static final int I = 1; 
  public void fight() {System.out.println("Fight");}
}

class Hero extends ActionCharacter 
    implements Fighter, Swimmer, Flyer {
  public void swim() {System.out.println("Swim ");}
  public void fly() {System.out.println("Fly");}
  // note we don't need to implement fight, why?
}

public class Adventure {
  static void fightNow(Fighter x) 
  	{ x.fight(); }
  static void swimNow(Swimmer x) 
  	{ x.swim(); }
  static void flyNow(Flyer x)
  	 { x.fly(); }
  static void actionNow(ActionCharacter x) 
  	{ x.fight(); }
  	
  public static void main(String[] args) {
    Hero h = new Hero();   
    fightNow(h); // Treat it as a Fighter
    swimNow(h); // Treat it as a Swimmer
    flyNow(h); // Treat it as a Flyer
    actionNow(h); // Treat it as an ActionCharacter
  }
} 