// Goals of this code to teach recursion
public class Reverse {
	
// recursive solution
public static String rreverse(String s) {
	int len = s.length();
    
    if (len <= 1) {// base case
      // System.out.println("base case with only one letter left: " + s);
      return s; // base case
    }
    else {
      char lastChar = s.charAt(len-1);
      String remainder = s.substring(0, len-1);
      // System.out.println(lastChar);
      return lastChar + rreverse(remainder);
    } 
}	
	
// reverse a string?  using iteration....
public static String ireverse(String s) {
	String tmp = "";
    for (int i = (s.length()-1); i>=0; i--) {
      tmp = tmp + s.charAt(i);
    }
    return tmp;
}

public static void main ( String[] args ) {	
	String mystr = "scoobydoo";
	String reversed = rreverse(mystr);
	System.out.println(mystr + " in reverse is done recursively:  " + reversed); 
	reversed = ireverse(mystr);
	System.out.println(mystr + " in reverse is done iteratively:  " + reversed); 
}
}
	
