// Goals of this code to teach recursion and compare to iteration
public class Stars {
	
	// iterative function that produces an output line of exactly n stars
	public static void writeStars(int n) {
  		for ( ; n > 0; n--)
    		System.out.print("*");
  		System.out.println(); 
	}

	// recursive function that produces an output line of exactly n stars
	public static void writeStars2(int n) {
  		if (n <= 0) {
    		System.out.println();
  		} else {
    		System.out.print("*");
    		writeStars2(n - 1);
  		}
	}

	public static void main ( String[] args ) {
		int n = 5; 
		writeStars(n);
    	writeStars2(n);	
	}
}