/**
 * @author nernst
 * 
 */
package doublelinkedlist;

public class LinkedQueue extends DoubleLinkedList implements Queue {

	public LinkedQueue() {
		super();
	}
	public Object dequeue() {
		return deleteLast();
	}
	public void enqueue(Object data) {
		insertFirst(data);
	}
	public Object front() {
		return getLast();
	}
	// methods size() and isEmpty()
	// are inherited from LinkedList

	public static void main(String[] args) {

		LinkedQueue lq = new LinkedQueue();
		lq.enqueue(new Double(9));
		lq.enqueue(new String("So long and thanks for all the..."));
		lq.enqueue(new Integer(55));
		lq.enqueue(new String("Lectures are best at 3.30 in the P.M."));
		
		while (  lq.isEmpty() != true ) {
			System.out.println(lq.size());
			Object obj = lq.dequeue();
			System.out.print("Size = " + lq.size() + " Obj = ");
			if (obj instanceof Integer) {
				int k = ((Integer) obj).intValue();
				System.out.println(k);
			} else if (obj instanceof String) {
				String str = (String) obj;
				System.out.println(str);
			} else {
				System.out.println("unknown");
			}
			System.out.println(lq.size());
		}
		if (lq.isEmpty())
			System.out.println("Empty Queue");
	}
}
